/********************************************************
 *  SKOLSKY ZVONCEK
 *=======================================================
 * Author  : Ing. Miroslav Tesar                  
 * Platform: Arduino NANO 328P
 * Version : 1.00
 * Date    : 03.12.2019
 * e-mail  : tesar@imt.eu.sk
 * ======================================================
 * DEFINICIA KONSTANT
 ********************************************************/

 /*******************************************************
  * DEFINICIA PINOV PRE DS3231
  *******************************************************/
 #define pin_SCL     19   // ! A5  Pin SCL pre DS3231
 #define pin_SDA     18   // ! A4  Pin SDA pre DS3231 
 
 /*******************************************************
  * DEFINICIA PINOV PRE TLACIDLA
  *******************************************************/
 #define pin_A2      17   // Kod tlacidla z obvodu 74HC148
 #define pin_A1      16   // Kod tlacidla z obvodu 74HC148
 #define pin_A0      15   // Kod tlacidla z obvodu 74HC148
 #define pin_GS       3   // Kod stlacenia tlacidla z obvodu 74HC148

 /*******************************************************
  * DEFINICIA PINOV PRE SD CARD
  *******************************************************/
 //                  NANO    MEGA
 #define pinSCK      13  // ! Pin pre SCK 
 #define pinMISO     12  // ! Pin pre MISO
 #define pinMOSI     11  // ! Pin pre MOSI
 #define pinCS       10  // ! Pin pre CS
 
 /*******************************************************
  * KONSTANTY PRE 74HC595
  *******************************************************/
 // DEKLARACIA PINOV
 #define pin_Clock    9  // Pin pre vstup SH_CP obvodu 74HC595
 #define pin_Latch    8  // Pin pre vstup ST_CP obvodu 74HC595
 #define pin_OE       7  // Pin pre vstup DS    obvodu 74HC595
 #define pin_Data     6  // Pin pre vstup DS    obvodu 74HC595

 /*******************************************************
  * DEFINICIA PINOV PRE tik sekundy a zopnutie rele
  *******************************************************/
 #define pin_Tik      5  // Pin pre blikanie sekundy
 #define pin_Rele     4  // Pin pre zopnutie rele

 /*******************************************************
  * INTERRUPT
  *******************************************************/
 #define pin_INT0     2  // ! INT0 pre DS3231 32K

/*******************************************************
 * KONSTANTY PRE DS3231
 *******************************************************/
 #define DS3231_I2C_ADDRESS 0x68  // Adresa DS3231
 #define DS3231_MIN_ADDRESS 0x01  // Adresa pozicie minuty
 #define DS3231_DlzkaCasu      3  // Pocet byte pre cas

/*******************************************************
 * KONSTANTY PRE 7-SEGMENTY
 *******************************************************/
//     Segment         decgfbah
 #define Znak0       0b11101110
 #define Znak1       0b00100100
 #define Znak2       0b11010110
 #define Znak3       0b10110110
 #define Znak4       0b00111100
 #define Znak5       0b10111010
 #define Znak6       0b11111010
 #define Znak7       0b00100110
 #define Znak8       0b11111110
 #define Znak9       0b10111110
 #define ZnakBlank   0b00000000
 #define Ned         0b01000000
 #define Pon         0b00000001
 #define Uto         0b00000010
 #define Str         0b00000100
 #define Stv         0b00001000
 #define Pia         0b00010000
 #define Sob         0b00100000
 #define ReleAno     0b10000000
 #define ReleNie     0b01111111
 #define Bodka       0b00000001
 #define ZnakE       0b11011010
 #define Znakr       0b01010000
//                     decgfbah

/*******************************************************
 * CHYBOVNIK
 *******************************************************/
 #define BezChyby       0 // Bez chyby
 #define ChybaSD        1 // Chyba inicializacie SD karty
 #define ChybaSubor     2 // Chyba suboru - neexistuje
 #define ChybaOtvor     3 // Chyba suboru - nejde otvorit

/*******************************************************
 * KONSTANTY CASOV
 *******************************************************/
 #define CasSekunda 32768 // Doba trvania sekundy
 #define CasTik     16384 // Doba trvania pol sekundy
 #define CasBlik     3276 // Doba trvania impulzu pre blikanie

/*******************************************************
 * KONSTANTY TLACIDIEL
 *******************************************************/
 #define _sipkaHore     0
 #define _sipkaVpravo   1
 #define _mode          2
 #define _sipkaVlavo    3
 #define _OE            4
 #define _sipkaDole     5

/*******************************************************
 * KONSTANTY POZICIE DNA
 *******************************************************/
 #define _Nedela        1
 #define _Pondelok      _Nedela + 1
 #define _Utorok        _Nedela + 2
 #define _Streda        _Nedela + 3
 #define _Stvrtok       _Nedela + 4
 #define _Piatok        _Nedela + 5
 #define _Sobota        _Nedela + 6
 
/*******************************************************
 * KONSTANTY HRANIC PRI NASTAVOVANI CISIEL
 *******************************************************/
 #define MaxNastav      4   // Max. pocet poloziek pre nastavenie disp.
 #define MinNastav      1   // Min. pocet poloziek pre nastavenie disp.
 #define PocNastav      3   // Prednastaveny bude Postfix
 
 #define MaxHod        23   // Maximalny pocet hodin
 #define MinHod         0   // Minimalny pocet hodin
 
 #define MaxMin        59   // Maximalny pocet minut
 #define MinMin         0   // Minimalny pocet minut
 
 #define MaxPoz   _Sobota   // Maximalny pocet dni v tyzdni
 #define MinPoz   _Nedela   // Minimalny pocet dni v tyzdni
 
 #define MaxPostfix     9   // Maximalny postfix suboru
 #define MinPostfix     0   // Minimalny postfix suboru

/*******************************************************
 * KONSTANTA FRONTY STRUKTURY UNION
 *******************************************************/
 #define DlzkaFronty    6   // Dlzba zaznamu v Byte

/*******************************************************
 * KONSTANTY PRIZNAKOV
 *******************************************************/
 #define Ano         true
 #define Nie        false

 
