/********************************************************
 *  SKOLSKY ZVONCEK
 *=======================================================
 * Author  : Ing. Miroslav Tesar                  
 * Platform: Arduino NANO 328P
 * Version : 1.00
 * Date    : 03.12.2019
 * e-mail  : tesar@imt.eu.sk
 * ======================================================
  * PREVODNIKY
 ********************************************************/

/*******************************************************
 * CONVERT BYTE LOW
 * -----------------------------------------------------
 * Konverzia cisla do dvoch 7-mi segmentovych displejov
 *******************************************************/
 byte ConvertByteLow (byte Cislo) {
   byte Result;
   
   Result = Cislo % 10;
   return Result;
 }

/*******************************************************
 * CONVERT BYTE HIGH
 * -----------------------------------------------------
 * Konverzia cisla do dvoch 7-mi segmentovych displejov
 *******************************************************/
 byte ConvertByteHigh (byte Cislo) {
   byte Result;
   
   Result = Cislo / 10;
   return Result;
 }

 /*******************************************************
  * DEC TO BCD
  * -----------------------------------------------------
  * Konverzia dekadickeho cisla do kodu BCD
  *******************************************************/
 byte decToBcd(byte val) {
   byte Result;

   Result = (val/10*16) + (val%10);
   return Result;
 }

 /*******************************************************
  * BCD TO DEC
  * -----------------------------------------------------
  * Konverzia kodu BCD do dekadickeho cisla
  *******************************************************/
 byte bcdToDec(byte val) {
   byte Result;

   Result = (val/16*10) + (val%16);
   return Result;
 }
  
/*******************************************************
 * KONVERZIA DO SEGMENTU
 * -----------------------------------------------------
 * Konverzia cisla do podoby 7-mi segmentoveho displeja
 *******************************************************/
 byte KonverziaDoSegmentu (byte Cislo) {
   byte Segment;
 
   switch (Cislo) {    // decgfba.
     case  0: Segment = Znak0; break;
     case  1: Segment = Znak1; break;
     case  2: Segment = Znak2; break; 
     case  3: Segment = Znak3; break; 
     case  4: Segment = Znak4; break; 
     case  5: Segment = Znak5; break; 
     case  6: Segment = Znak6; break; 
     case  7: Segment = Znak7; break;
     case  8: Segment = Znak8; break;
     case  9: Segment = Znak9; break;
     case 10: Segment = ZnakBlank; break;
   }    
   return Segment;
 }

/*******************************************************
 * KONVERZIA DO POZDEN
 * -----------------------------------------------------
 * Konverzia cisla do jednoho 7-mi segmentoveho displeja
 * v tomto pripade do segmentu nazvu dna v tyzdni
 *******************************************************/
 byte KonverziaPozDen (byte Cislo){
   byte Segment;

   switch (Cislo) {
     case _Nedela   : Segment = Ned; break;
     case _Pondelok : Segment = Pon; break;
     case _Utorok   : Segment = Uto; break;
     case _Streda   : Segment = Str; break;
     case _Stvrtok  : Segment = Stv; break;
     case _Piatok   : Segment = Pia; break;
     case _Sobota   : Segment = Sob; break;
   }
   return Segment;
 }

/*******************************************************
 * KONVERTUJ 01
 * -----------------------------------------------------
 * Konverzia cisla do dvoch 7-mi segmentovych displejov
 * Jednotkova pozicia
 *******************************************************/
 byte Konvertuj_01 (byte Cislo){
   byte Tmp;

   Tmp = ConvertByteLow (Cislo);    // (30)
   KonverziaDoSegmentu(Tmp);        // (30)
   return Tmp;
 }

/*******************************************************
 * KONVERTUJ 10
 * -----------------------------------------------------
 * Konverzia cisla do dvoch 7-mi segmentovych displejov
 * Desiatkova pozicia
 *******************************************************/
 byte Konvertuj_10 (byte Cislo){
   byte Tmp;

   Tmp = ConvertByteHigh (Cislo);   // (30)
   KonverziaDoSegmentu(Tmp);        // (30)
   return Tmp;
 }
 
