/********************************************************
 *  SKOLSKY ZVONCEK
 *=======================================================
 * Author  : Ing. Miroslav Tesar                  
 * Platform: Arduino NANO 328P
 * Version : 1.00
 * Date    : 03.12.2019
 * e-mail  : tesar@imt.eu.sk
 * ======================================================
 * Spracovanie perusenia od INT
 ********************************************************/
   
/*******************************************************
 * RTC32K
 * RTC generuje sekundu pre ziaskani casu a teploty
 *******************************************************/
 void RTC32K() {
  
   if (Premenna.DelickaCas < CasSekunda){ // 32768Hz = 1 sec
     Premenna.DelickaCas++; 
   }
   else {                                 // Zbehla sekunda
     Premenna.DelickaCas = 0;  
     Premenna.PriznakMinuta = Ano;
   }

   if (Premenna.DelickaBlik < CasBlik){   // 8192Hz = 1/4 sec
     Premenna.DelickaBlik ++; 
   }
   else {                                 // Zbehla sekunda
     Premenna.DelickaBlik = 0;  
     Premenna.PriznakBlik = Ano;
   }
  
   if (Premenna.DelickaTik < CasTik){     // Pol sekundy
     Premenna.DelickaTik++; 
   }
   else {                                 // Zbehla polsekunda
     Premenna.PriznakTik = !Premenna.PriznakTik;
     digitalWrite(pin_Tik,Premenna.PriznakTik);
     Premenna.DelickaTik = 0;  
   }
 }
    
/*******************************************************
 * CITAJ CAS Z DS3231
 * -----------------------------------------------------
 * Citaj udaje casu z DS3231
 *******************************************************/
 void CitajCasDS3231() {
   Wire.beginTransmission(DS3231_I2C_ADDRESS);
   Wire.write(DS3231_MIN_ADDRESS); // set DS3231 register pointer to 01h
   Wire.endTransmission();  
   Wire.requestFrom(DS3231_I2C_ADDRESS,DS3231_DlzkaCasu);                              
                                          
   DisplejCas.Minuty     = bcdToDec(Wire.read());        // (30)
   DisplejCas.Hodiny     = bcdToDec(Wire.read() & 0x3f); // (30) 
   DisplejCas.PozDne     = bcdToDec(Wire.read());        // (30)
   DisplejCas.PocetMinut = (DisplejCas.Hodiny *60) + DisplejCas.Minuty;

   if (DisplejCas.Minuty != Premenna.PamatMinuty) {
     Premenna.PamatMinuty = DisplejCas.Minuty;
     Premenna.PriznakMinuty = Ano; // Priznak, ze sa zmenila minuta
   }
 }
    
/*******************************************************
 * ZAPIS DS3231
 * -----------------------------------------------------
 * Zapis data do DS3231
 *******************************************************/
 void ZapisCasDS3231(byte minuty , byte hodiny, byte pozDne)
 {
   Wire.beginTransmission(DS3231_I2C_ADDRESS);
   Wire.write(DS3231_MIN_ADDRESS); // set DS3231 register pointer to 01h

   Wire.write(decToBcd(minuty ));   // (30)
   Wire.write(decToBcd(hodiny ));   // (30)
   Wire.write(decToBcd(pozDne ));   // (30)
   Wire.endTransmission();                                  
 }

    
