/********************************************************
 *  SKOLSKY ZVONCEK
 *=======================================================
 * Author  : Ing. Miroslav Tesar                  
 * Platform: Arduino NANO 328P
 * Version : 1.00
 * Date    : 03.12.2019
 * e-mail  : tesar@imt.eu.sk
 * ======================================================
 * SEGMENTY
 ********************************************************/
     
/*******************************************************
 * ZAPIS 7 SEGMENT
 * -----------------------------------------------------
 * Zapis data do DS3231
 *******************************************************/
 void ZapisCas7segment() {
   byte Tmp;

   Tmp = ConvertByteHigh (DisplejCas.Hodiny);     // (30)
   Cas_HC595.Hod10 = KonverziaDoSegmentu (Tmp);   // (30)

   Tmp = ConvertByteLow (DisplejCas.Hodiny);      // (30)
   Cas_HC595.Hod01 = KonverziaDoSegmentu (Tmp);   // (30)

   Tmp = ConvertByteHigh (DisplejCas.Minuty);     // (30)
   Cas_HC595.Min10 = KonverziaDoSegmentu (Tmp);   // (30)

   Tmp = ConvertByteLow (DisplejCas.Minuty);      // (30)
   Cas_HC595.Min01 = KonverziaDoSegmentu (Tmp);   // (30)

   Cas_HC595.PozDne = KonverziaPozDen (DisplejCas.PozDne);// (30)

   Tmp = Konvertuj_01 (DisplejCas.Postfix);       // (30) 
   Cas_HC595.Postfix = KonverziaDoSegmentu (Tmp); // (30)
    
   saveFronta(&Cas_HC595.Fronta[0]);              // (20)
 }
  
/********************************************************
 * RELE
 ********************************************************/
 void Zvoni() {
   digitalWrite(pin_Rele ,Ano);
   Cas_HC595.PozDne |= ReleAno; 
   saveFronta(&Cas_HC595.Fronta[0]);              // (20)  
 }
  
/********************************************************
 * RELE
 ********************************************************/
 void Nezvoni() {
   digitalWrite(pin_Rele ,Nie);
   Cas_HC595.PozDne &= ReleNie; 
   saveFronta(&Cas_HC595.Fronta[0]);              // (20)  
 }
  
/********************************************************
 * RELE
 ********************************************************/
 void VystupRele() {
   Zvoni();                                       // (50)
   Serial.print(F(" Zvoni "));
   delay (SDHodnota.ZvoncekSekundy); 
   Nezvoni();                                     // (50)
  }

 
