/********************************************************
 *  SKOLSKY ZVONCEK
 *=======================================================
 * Author  : Ing. Miroslav Tesar                  
 * Platform: Arduino NANO 328P
 * Version : 1.00
 * Date    : 03.12.2019
 * e-mail  : tesar@imt.eu.sk
 * ======================================================
 * RTC
 ********************************************************/

/********************************************************
 * ANALYZUJ RIADOK
 ********************************************************/
 AnalyzujRiadok() {
   while (SDHodnota.PocetMinut < DisplejCas.PocetMinut) {
     CitajRiadok();       // (20)
     if (Premenna.PriznakKoniec) break;
   }
 }

/********************************************************
 * ANALYZUJ ZVONENIE
 ********************************************************/
 AnalyzujZvonenie() {
   Serial.print(F("DisplejCas.PozDne: "));
   Serial.print(DisplejCas.PozDne);
   Serial.print("  DisplejCas.PocetMinut ");
   Serial.print(DisplejCas.PocetMinut);
   switch (DisplejCas.PozDne) {
     case _Nedela   : if (SDHodnota.Nedela  ) VystupRele();  // (50)
                      Serial.print  ("  Nedela ");     
                      Serial.println(SDHodnota.Nedela);     
                      break;
     case _Pondelok : if (SDHodnota.Pondelok) VystupRele();  // (50)
                      Serial.print  ("  Pondelok ");     
                      Serial.println(SDHodnota.Pondelok);     
                      break;
     case _Utorok   : if (SDHodnota.Utorok  ) VystupRele();  // (50)
                      Serial.print  ("  Utorok ");     
                      Serial.println(SDHodnota.Utorok);     
                      break;
     case _Streda   : if (SDHodnota.Streda  ) VystupRele();  // (50)
                      Serial.print  ("  Streda ");     
                      Serial.println(SDHodnota.Streda);     
                      break;
     case _Stvrtok  : if (SDHodnota.Stvrtok ) VystupRele();  // (50)
                      Serial.print  ("  Stvrtok ");     
                      Serial.println(SDHodnota.Stvrtok);     
                      break;
     case _Piatok   : if (SDHodnota.Piatok  ) VystupRele();  // (50)
                      Serial.print  ("  Piatok ");     
                      Serial.println(SDHodnota.Piatok);     
                      break;
     case _Sobota   : if (SDHodnota.Sobota  ) VystupRele();  // (50)
                      Serial.print  ("  Sobota ");     
                      Serial.println(SDHodnota.Sobota);     
                      break;        
   }
 }
 
/*******************************************************
 * RTC HODINY PLUS
 *******************************************************/
 void rtcHodinyPlus() {
   if (DisplejCas.Hodiny < MaxHod) {
     DisplejCas.Hodiny++;
     ZapisCasDS3231(DisplejCas.Minuty, DisplejCas.Hodiny, 
                    DisplejCas.PozDne);
     ZapisCas7segment();  // (50)
     Premenna.ZmenaCasu = Ano;
   }                      
 }

/*******************************************************
 * RTC HODINY MINUS
 *******************************************************/
 void rtcHodinyMinus() {
   if (DisplejCas.Hodiny > MinHod) {
     DisplejCas.Hodiny--;
     ZapisCasDS3231(DisplejCas.Minuty, DisplejCas.Hodiny, 
                    DisplejCas.PozDne);
     ZapisCas7segment();  // (50)
     Premenna.ZmenaCasu = Ano;
   } 
 }

/*******************************************************
 * RTC MINUTY PLUS
 *******************************************************/
 void rtcMinutyPlus() {
   if (DisplejCas.Minuty < MaxMin) {
     DisplejCas.Minuty ++;
     ZapisCasDS3231(DisplejCas.Minuty, DisplejCas.Hodiny, 
                    DisplejCas.PozDne);
   }
   ZapisCas7segment();    // (50)
   Premenna.ZmenaCasu = Ano;
 }

/*******************************************************
 * RTC MINUTY MINUS
 *******************************************************/
 void rtcMinutyMinus() {
   if (DisplejCas.Minuty > MinMin) {
     DisplejCas.Minuty --;
     ZapisCasDS3231(DisplejCas.Minuty, DisplejCas.Hodiny, 
                    DisplejCas.PozDne);
   }
   ZapisCas7segment();    // (50)
   Premenna.ZmenaCasu = Ano;
 }

/*******************************************************
 * SUBOR PLUS
 *******************************************************/
 void suborPlus() {
   if (DisplejCas.Postfix < MaxPostfix) {
     DisplejCas.Postfix ++;
   }
   else DisplejCas.Postfix = MinPostfix;
   
   ZapisCas7segment();    // (50)
   Premenna.ZmenaPostfixu = Ano;
   Premenna.PriznakKoniec = Nie;       // Priznak konca suboru 
 }

/*******************************************************
 * SUBOR PLUS
 *******************************************************/
 void suborMinus() {
   if (DisplejCas.Postfix > MinPostfix) {
     DisplejCas.Postfix --;
   }
   else DisplejCas.Postfix = MaxPostfix;
   
   ZapisCas7segment();    // (50)
   Premenna.ZmenaPostfixu = Ano;
   Premenna.PriznakKoniec = Nie;       // Priznak konca suboru 
 }

/*******************************************************
 * RTC POZ MINUS
 *******************************************************/
 void rtcPozPlus() {
   if (DisplejCas.PozDne < MaxPoz) {
     DisplejCas.PozDne ++;
   } 
   else DisplejCas.PozDne = MinPoz;
   
   ZapisCasDS3231(DisplejCas.Minuty, DisplejCas.Hodiny, 
                  DisplejCas.PozDne);
   ZapisCas7segment();    // (50)
 }

/*******************************************************
 * RTC POZ PLUS
 *******************************************************/
 void rtcPozMinus() {
   if (DisplejCas.PozDne > MinPoz) {
     DisplejCas.PozDne --;
   }
   else DisplejCas.PozDne = MaxPoz;
   
   ZapisCasDS3231(DisplejCas.Minuty, DisplejCas.Hodiny, 
                  DisplejCas.PozDne);
   ZapisCas7segment();    // (50)
 }

/*******************************************************
 * ZOBRAZOVANIE CASU
 *******************************************************/
 void RezimCas() {
   if (Premenna.PriznakMinuta) { 
     CitajCasDS3231();                    // (40)
     ZapisCas7segment();                  // (50)
     Premenna.Tik = !Premenna.Tik;
     digitalWrite(pin_Tik,Premenna.Tik);  // Blikanie sekundovky
     Premenna.PriznakMinuta = Nie;
   }
 }
