/********************************************************
 *  SKOLSKY ZVONCEK
 *=======================================================
 * Author  : Ing. Miroslav Tesar                  
 * Platform: Arduino NANO 328P
 * Version : 1.00
 * Date    : 03.12.2019
 * e-mail  : tesar@imt.eu.sk
 * ======================================================
 * FFUNKCIE TLACIDIEL
 ********************************************************/

/********************************************************
 * BLIKANIE
 ********************************************************/
 void Blikanie() {
   if (Premenna.Mod) {  // Bol stlaceny klaves Mod
     if (Premenna.PriznakBlik == Ano) {
       for(byte i=0;i<DlzkaFronty;i++) // Fill <- Cas_HC595
         FillFronta[i] = Cas_HC595.Fronta[i];

       switch (Premenna.PriznakNastavCas) { // Zhasni vybraty udaj
         case 1: FillFronta[5] = 0;         // Hodiny10
                 FillFronta[4] = 0; break;  // Hodiny01
         case 2: FillFronta[3] = 0;         // Minuty10
                 FillFronta[2] = 0; break;  // Minuty01
         case 3: FillFronta[1] = 0; break;  // PozDny
         case 4: FillFronta[0] = 0; break;  // rezim
       }

       if  (Premenna.Tik) saveFronta(&FillFronta[0]);        // (20)
       else               saveFronta(&Cas_HC595.Fronta[0]);  // (20)
    
       Premenna.Tik = !Premenna.Tik;
       Premenna.PriznakBlik = Nie;
     }  
   }
 }

/********************************************************
 * TLAC HORE
 ********************************************************/
 void TlacHore() {
   if (Premenna.Mod) {
     switch (Premenna.PriznakNastavCas) {
       case 1: rtcHodinyPlus(); break;  // (60) Nastavenie hodin
       case 2: rtcMinutyPlus(); break;  // (60) Nastavenie minut
       case 3: suborPlus()    ; break;  // (60) Nastavenie suboru
       case 4: rtcPozPlus()   ; break;  // (60) Nastavenie pozicie dna
     }
   }
   else Zvoni();                        // (50) 
 }

/********************************************************
 * TLAC DOLE
 ********************************************************/
 void TlacDole() {
   if (Premenna.Mod) {
     switch (Premenna.PriznakNastavCas) {
       case 1: rtcHodinyMinus(); break; // (50) Nastavenie hodin
       case 2: rtcMinutyMinus(); break; // (50) Nastavenie minut
       case 3: suborMinus()    ; break; // (50) Nastavenie suboru
       case 4: rtcPozMinus()   ; break; // (50) Nastavenie pozicie dna
     }
   }
   else Nezvoni();                      // (50)
 }

/********************************************************
 * TLAC VPRAVO
 ********************************************************/
 void TlacVpravo() {
   if (Premenna.Mod) {
     if(Premenna.PriznakNastavCas > MinNastav)
       Premenna.PriznakNastavCas --;
     else Premenna.PriznakNastavCas = MaxNastav;
   }
 }

/********************************************************
 * TLAC VLAVO
 ********************************************************/
 void TlacVlavo() {
   if (Premenna.Mod) {
     if(Premenna.PriznakNastavCas < MaxNastav)
       Premenna.PriznakNastavCas ++;
     else Premenna.PriznakNastavCas = MinNastav;
   }
 }

/********************************************************
 * TLAC MOD
 * ======================================================
 * Rezim zap/vyp - nastavenie casu a volby suboru
 ********************************************************/
 void TlacMod() {
   Premenna.Mod = !Premenna.Mod;                
   Premenna.PriznakNastavCas = PocNastav;  
   if(!Premenna.Mod) {
     saveFronta(&Cas_HC595.Fronta[0]);     // (20)

     if(Premenna.ZmenaPostfixu) {          // Pri zmene postfixu
       Zaznam.close();

       KonvertujPostfix();                 // (20) Kvoji otvoreniu suboru
       Premenna.Chyba = ChybaSubor;        // Nastav neexistenciu suboru
       InitSubor();                        // (20) Skus Init
       if(Premenna.Chyba == ChybaSubor) {  // Subor neexistuje 
         InitSubor();                      // (20)
       }
        
       EEPROM.write(AdresaEEPROM,DisplejCas.Postfix);
       OtvorSubor();                      // (20)
       CitajRiadok();                     // (20)
       AnalyzujRiadok();                  // (80)
       Premenna.PriznakMinuty = Nie;
       Premenna.PriznakPolnoc = Ano;  
     }

     if(Premenna.ZmenaCasu) {          // Pri zmene casu
       Zaznam.close();
       OtvorSubor();                      // (20)
       CitajRiadok();                     // (20)
       AnalyzujRiadok();                  // (80)
       Premenna.ZmenaCasu = Nie;
     }
   }
 }

/********************************************************
 * TLAC OE
 * ======================================================
 * Rezim zap/vyp - nastavenie casu a volby suboru
 ********************************************************/
 void TlacOE() {
   Premenna.PriznakOE = !Premenna.PriznakOE;                
   digitalWrite(pin_OE,Premenna.PriznakOE);  // Zhasni/rozsvit
   if(!Premenna.PriznakOE) ZapisCas7segment(); // (50)
 }

/*******************************************************
 * POVELY Z TLACIDIEL
 *******************************************************/
 void Tl_Mod(){
   int Kod = 0;

   delay(10);
   if(digitalRead(pin_A2)) Kod += 4;  // Vaha tlacidla
   if(digitalRead(pin_A1)) Kod += 2;  // Vaha tlacidla
   if(digitalRead(pin_A0)) Kod += 1;  // Vaha tlacidla
  
   switch(Kod) {
     case _sipkaDole   : TlacDole  (); break;  // (70)
     case _OE          : TlacOE    (); break;  // (70)
     case _sipkaHore   : TlacHore  (); break;  // (70)
     case _sipkaVlavo  : TlacVlavo (); break;  // (70)
     case _mode        : TlacMod   (); break;  // (70)
     case _sipkaVpravo : TlacVpravo(); break;  // (70)
   }
 
   while (!digitalRead(pin_GS)) {};   // Ak je tlacidlo stlacene
   
   Premenna.PriznakTlacidla= Nie;     // Priznak stlaceneho tlacidla
 }

 
